Add action

  • POST
  • /workspaces
  • /:workspace
  • /projects
  • /:project_name
  • /pipelines
  • /:pipeline_id
  • /actions

Creates a new action in the pipeline

Request

REQUIRED SCOPES
EXECUTION_MANAGE
URL PARAMETERS
workspacerequiredstring
The human-readable ID of the workspace

Example: "my-company"

project_namerequiredstring
The human-readable ID of the project

Example: "my-project"

pipeline_idrequiredinteger
The ID of the pipeline

Example: 123

POST PARAMETERS
typerequiredstring
The type of the action
Allowed enum:
TRANSFER,
AMAZON_S3,
WEB_DAV,
SSH_COMMAND,
HTTP,
SLACK,
EMAIL,
SMS,
PUSH,
HEROKU,
BUILD,
PING,
WEB,
TCP,
RUN_NEXT_PIPELINE,
ELASTIC_BEANSTALK,
GCS,
SHOPIFY,
PUSHOVER,
PUSHBULLET,
CODE_DEPLOY,
AZURE,
DOCKERFILE,
GOOGLE_APP_ENGINE,
LAMBDA,
HEROKU_CLI,
RACKSPACE,
CLOUDFLARE,
CLOUD_FRONT,
MONITOR,
SLEEP,
AWS_CLI,
GOOGLE_CDN,
AWS_LAMBDA_DEPLOY,
KUBERNETES_APPLY,
KUBERNETES_SET_IMAGE,
KUBERNETES_RUN_POD,
WAIT_FOR_APPLY,
APPROVE_VT,
NEW_RELIC,
KUBERNETES_RUN_JOB,
ZIP,
ROLLBAR,
SENTRY,
DATADOG,
DO_SPACES,
HONEYBADGER,
SENTRY_ENTERPRISE,
LOGGLY,
KUBERNETES_CLI,
RUN_DOCKER_CONTAINER,
ESLINT,
DOCKER_PUSH,
ANDROID_SIGN,
ANDROID_PLAY,
WAIT_FOR_VARIABLES,
GCLOUD_CLI,
AWS_ECS,
COPY_FILES,
FIREBASE,
TELEGRAM,
REPLACE,
GOOGLE_FUNCTIONS_DEPLOY,
GOOGLE_FUNCTIONS,
BUGSNAG,
SPLIT_TESTS,
RAYGUN,
DATADOG_STATUS_CHECK,
GHOST_INSPECTOR,
AWS_CLOUD_FORMATION,
DIGITAL_OCEAN_CDN,
DISCORD2,
IMAGE_COMPRESSION,
NETLIFY,
GIT_CRYPT_UNLOCK,
GIT_CRYPT_LOCK,
HELM,
DOCKERFILE_LINTER,
DOWNLOAD,
DOWNLOAD_S3,
LIGHTHOUSE,
ANDROID_SIGN_BUNDLE,
ANDROID_PLAY_BUNDLE,
VISUAL_TESTS,
VISUAL_TEST_2,
LINK_VALIDATOR,
AZURE_CLI,
SHOPIFY_THEMEKIT_CLI,
SSL_VERIFY,
AZURE_STORAGE,
DEPLOY_TO_SANDBOX,
SANDBOX_START,
SANDBOX_STOP,
SANDBOX_EXEC,
GIT_HUB_RELEASE,
GCLOUD_RUN_DEPLOY,
SANDBOX_SNAPSHOT,
AWS_CLI_2,
MICROSOFT_TEAMS,
NATIVE_BUILD_WINDOWS,
NATIVE_BUILD_MAC,
DOCTL,
NATIVE_BUILD_MAC_REACT,
NATIVE_BUILD_MAC_CORDOVA,
NATIVE_BUILD_MAC_FASTLANE,
NATIVE_BUILD_MAC_FLUTTER,
GOOGLE_CLOUD_STORAGE,
GOOGLE_FUNCTION_DEPLOY,
GOOGLE_FUNCTION_INVOKE,
GOOGLE_CDN_INVALIDATE,
GOOGLE_CLOUD_CLI,
GOOGLE_CLOUD_RUN_DEPLOY,
GOOGLE_APP_DEPLOY,
ANDROID_PUBLISH_APK,
ANDROID_PUBLISH_APP_BUNDLE,
SANDBOX_CREATE_NEW,
SANDBOX_CREATE_FROM_SANDBOX,
SANDBOX_CREATE_FROM_SNAPSHOT,
SANDBOX_DELETE,
NATIVE_BUILD_MAC_SIGN,
NATIVE_BUILD_MAC_DEPLOY,
NATIVE_BUILD_DOCKER_CLI,
CLEAR_CACHE,
FASTLANE_ANDROID,
NATIVE_BUILD_LINUX,
GIT_HUB_CLI,
INTEGRATION_VARIABLES,
DOCKER_BUILD_MULTI_ARCH,
CODE_PIPELINE,
GIT_LAB_CLI,
AWS_APP_RUNNER_DEPLOY,
AWS_APP_RUNNER_MONITOR,
NATIVE_BUILD_MAC_VM,
AWS_CDK_CLI,
GHOST_INSPECTOR_CLI,
TERRAFORM,
ATOP,
SNYK_CLI,
STACK_HAWK_CLI,
JMETER_CLI,
CUSTOM,
BLACKFIRE_PHP,
BLACKFIRE_PYTHON,
BLACKFIRE_GO,
LINK_CHECKER,
SHOPIFY_CLI,
DOCKER,
SET_VARIABLES,
DOWNLOAD_FROM_SANDBOX,
PIPELINE_SETTINGS,
BACKBLAZE_B2,
NEW_RELIC_CLI,
DOWNLOAD_GCS,
DOWNLOAD_BACKBLAZE_B2,
WP_CLI,
GOOGLE_CHAT,
SANDBOX_APPLICATION_START,
SANDBOX_APPLICATION_STOP,
POWERSHELL,
SANDBOX_MANAGE,
SANDBOX_CREATE,
CONTENTFUL_CLI,
JIRA_BUILD,
JIRA_DEPLOYMENT,
MYSQL_CLI,
FTP,
FTPS,
SFTP,
GCE,
VULTR,
UPCLOUD,
DIGITAL_OCEAN,
DOWNLOAD_FTP,
DOWNLOAD_FTPS,
DOWNLOAD_SSH,
RSYNC,
PROMOTE_IMAGE,
PUBLISH_PACKAGE_VERSION,
DOWNLOAD_PACKAGE_VERSION,
STORYBOOK
urlread-onlystring
API endpoint to GET this object
html_urlread-onlystring
Web URL to view this object in Buddy.works
after_action_idinteger
The numerical ID of the action, after which this action should be added
namerequiredstring
The name of the action
trigger_timestring enum
Specifies when the action should be executed
Allowed enum:
ON_EVERY_EXECUTION,
ON_SUCCESS,
ON_FAILURE,
ON_BACK_TO_SUCCESS,
ON_WARNING,
ON_WAIT_FOR_APPROVE,
ON_TERMINATE
trigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggered
run_nextstring enum
Defines whether the action should run in parallel with the next one
Allowed enum:
WAIT_ON_SUCCESS,
IN_SOFT_PARALLEL,
IN_HARD_PARALLEL
run_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILURE
variablesEnvironmentVariableView[]
The list of variables you can use the action
disabledboolean
When set to true the action is disabled. By default it is set to false
timeoutinteger
The timeout in seconds
ignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actions
retry_countinteger
Number of retries if the action fails
retry_intervalinteger
Delay time between auto retries in seconds
loopstring[]
The list of commands that will be executed in a loop
current_revisionstring
The git revision of the last successful run of the action
permissionsPermissionsView
Access permissions configuration
Hint
On top of these properties every action has a set of properties unique to its type. You can read how to define each type in separate articles below.
ACTIONS

Last modified on Mar 18, 2026

Request example

CURL
curl -X POST "https://api.buddy.works/workspaces/:workspace/projects/:project_name/pipelines/:pipeline_id/actions" \ -H "Authorization: Bearer <YOUR-TOKEN>" \ -H "Content-Type: application/json"
EXAMPLE RESPONSE
{ "url": "https://api.buddy.works/workspaces/my-workspace/projects/my-project/pipelines/791/actions/1233", "html_url": "https://app.buddy.works/my-workspace/my-project/pipelines/pipeline/791/action/1233/edit", "id": 1233, "name": "mvn package", "type": "BUILD", "current_revision": "58e239079a2161fec0ba96ed166557157ad3dd79", "trigger_time": "ON_EVERY_EXECUTION", "run_next": "WAIT_ON_SUCCESS", "disabled": false, "ignore_errors": false, "pipeline": { "url": "https://api.buddy.works/workspaces/my-workspace/projects/my-project/pipelines/791", "html_url": "https://app.buddy.works/my-workspace/my-project/pipelines/pipeline/791", "id": 791, "identifier": "build", "name": "build", "definition_source": "LOCAL", "git_config_ref": "NONE", "refs": [ "refs/heads/master" ], "events": [ { "type": "WEBHOOK" } ], "priority": "NORMAL", "disabled": false, "last_execution_status": "SUCCESSFUL", "last_execution_revision": "58e239079a2161fec0ba96ed166557157ad3dd79", "always_from_scratch": false, "ignore_fail_on_project_status": false, "strict_context": false, "no_skip_to_most_recent": false, "terminate_stale_runs": false, "auto_clear_cache": false, "fetch_all_refs": false, "fail_on_prepare_env_warning": true, "concurrent_pipeline_runs": false, "do_not_create_commit_status": false, "stale": false, "waiting_for_push": false, "resources": "DEFAULT", "git_changeset_base": "LATEST_RUN", "filesystem_changeset_base": "DATE_MODIFIED", "cpu": "X64", "description_required": false }, "loop": [], "docker_image_name": "library/maven", "docker_image_tag": "3.9.9", "execute_commands": [ "mvn package" ], "mount_filesystem_disable": false, "volume_mappings": [ "/:/buddy/my-project" ], "cached_dirs": [ "/root/.m2/repository" ], "shell": "BASH", "region": "", "image_location": "PUBLIC_REGISTRY", "docker_registry": "DOCKER_HUB", "execute_every_command": false, "ignore_image_pull_failures": false, "cache_base_image": true, "reset_entrypoint": false, "vt_suite": "" }
STATUS
200 OK